/* Shader for texture mapping the leaves
 *
 * The Blue Moon Rendering Tools (BMRT) are:
 * (c) Copyright 1990-2000 Exluna, Inc. and Larry Gritz. All rights reserved.
 */


surface
leaf ( float Ka = 1, Kd = 1, Ks = .2, roughness = .1;
		 color specularcolor = 1;
		 string texturename = ""; )
{
   color tc;
   float tt;
   string tname;

    Ci = Cs;
       if (texturename != "") {
       	   if (match(".tif",texturename)==0.0)
           	tname = concat(texturename,".tif");   
           else tname = texturename;
            
     } else tname = "leaf.tif";
       
         	
    tc = color texture (tname,s,t,"swidth",0.1*s,"twidth",t*5);
    tt = float texture (tname[3],"fill",1.0,"width",0.0);
    
    if (tt<0.9){
        Os = 0.0;
        }


    Ci *= tc;

    normal Nf = faceforward (normalize(N),I);
      
    color rf = (Ka*ambient() + Kd*diffuse(Nf)) +
	       specularcolor * Ks*specular(Nf,-normalize(I),roughness);

/* fuer Beleuchtung von hinten

    Nf = faceforward (normalize(N),-I);      
    color tf = 2*Kd*diffuse(Nf);

    Ci *= rf+tf;
*/
    Ci *= rf;

    Oi = Os;  Ci *= Oi;

}




